// Craig S. Kaplan
// A simplest demonstration of direct manipulation: move a 
// single circle around the sketch window.

// A constant for the size of the circle.
float rad = 30;

// Centre of the the circle.
float cx;
float cy;

// Are we currently dragging the circle?
boolean active;

void setup()
{
  size( 500, 500 );
  cx = width / 2;
  cy = height / 2;
}

void draw()
{
  background( 80 );
  fill( 255 );
  stroke( 0 );
  strokeWeight( 3 );
  
  ellipse( cx, cy, 2 * rad, 2 * rad );
}

void mousePressed()
{
  // Hit test: check if the mouse position is close
  // to the location of the circle, using the built-in
  // dist() function.
  float d = dist( cx, cy, mouseX, mouseY );
  if ( d < rad ) {
    active = true;
  }
}

void mouseDragged()
{
  if ( active ) {
    cx += mouseX - pmouseX;
    cy += mouseY - pmouseY;
  }
}

void mouseReleased()
{
  active = false;
}