// Craig S. Kaplan
// A more elaborate demonstration of ControlP5 in which there
// are a few buttons, and we decide what action to take depending
// on which button was pressed.

import controlP5.*;

ControlP5 ui;
Button circle_button;
Button rect_button;
Button clear_button;

void setup()
{
  size( 400, 300 );
  ui = new ControlP5( this );

  PFont fnt = createFont( "Helvetica", 18 );
  ui = new ControlP5( this, fnt );

  circle_button = ui.addButton( "Circle" )
    .setPosition( 10, 10 )
    .setSize( 120, 30 );
  rect_button = ui.addButton( "Rectangle" )
    .setPosition( 10, 50 )
    .setSize( 120, 30 );
  clear_button = ui.addButton( "Clear" )
    .setPosition( 10, 90 )
    .setSize( 120, 30 );

  background( 220 );
}

void draw()
{
}

void controlEvent( ControlEvent ev )
{
  fill( random(255), random(255), random(255) );

  if ( ev.isFrom( circle_button ) ) {
    // Create a random circle.
    float r = random( 10, 40 );
    float x = random( 100 + r, width - r );
    float y = random( r, height - r );
    ellipse( x, y, 2*r, 2*r );
  } else if ( ev.isFrom( rect_button ) ) {
    // Create a random rectangle.
    float w = random( 10, 60 );
    float h = random( 10, 60 );
    float x = random( 100 + w, width - w );
    float y = random( h, height - h );
    rect( x, y, w, h );
  } else if ( ev.isFrom( clear_button ) ) {
    // Clear the canvas.
    background( 220 );
  }
}